let appConfigMap = {}
//从IDaaS获取配置
const getConfigFromIDaaS = function(type){
    //将数据存储到本地
    // if(type) {
    //     $.ajax({
    //         url: "./config/"+ type +"_config.json",//json文件位置
    //         type: "GET",//请求方式为get
    //         dataType: "json", //返回数据格式为json
    //         sync: true,
    //         success: function(res){
    //             sendMessageToContentScript({ idaas_config: res });
    //         }
    //     })
    // }
}

// 监听来自content-script的消息
chrome.extension.onRequest.addListener(function(request, sender, sendResponse) {
    // 保存配置
    const idaas_config = request.setConfig;
    // 当前页面的url
    const getConfig = request.getConfig;
    // 获取配置
    console.log(getConfig);
    if (idaas_config) appConfigMap[idaas_config.appId] = idaas_config;
    if (getConfig) {
        // 查找是否可以代填
        for (let key in appConfigMap){
           if(appConfigMap[key].config.frameUrl && appConfigMap[key].config.frameUrl.frameUrl !== ''){
                if (getConfig.indexOf(appConfigMap[key].config.frameUrl) > -1) {
                    // 代填
                    sendMessageToContentScript({ idaas_config: appConfigMap[key] });
                }
            } else {
                if (getConfig.indexOf(appConfigMap[key].config.loginUrl) > -1) {
                    // 代填
                    sendMessageToContentScript({ idaas_config: appConfigMap[key] });
                }
            }
        }
    }
    // 移除配置
    const removeConfig = request.removeConfig;
    if(removeConfig){
        // 代填成功后清除配置
        if (appConfigMap[removeConfig]) delete appConfigMap[removeConfig];
    }
    // 获取插件版本
    const getVersion = request.getVersion;
    if(getVersion){
        $.get(chrome.extension.getURL('manifest.json'), function(info){
            sendMessageToContentScript({ version: info.version });
        }, 'json');
    }
    //给 sender 发送响应消息
    sendResponse({});
    return true;
})

//向content主动发送消息
// active: true, currentWindow: true
function sendMessageToContentScript(message, callback){
    chrome.tabs.query({active: true}, function(tabs){
        chrome.tabs.sendRequest(tabs[0].id, message, function(response){
            if(callback){
            	callback(response);
            }
        });
    });
}


chrome.webRequest.onBeforeRequest.addListener(function(details){
    if(details.type !== "stylesheet" && details.type !== "script" && details.type !== "image" && details.type !== "xmlhttprequest"){
        for (let key in appConfigMap){
            if(appConfigMap[key].config.frameUrl && appConfigMap[key].config.frameUrl.frameUrl !== ''){
                if (details.url.indexOf(appConfigMap[key].config.frameUrl) > -1) {
                    // 代填
                    sendMessageToContentScript({ idaas_config: appConfigMap[key] });
                }
            } else {
                if (details.url.indexOf(appConfigMap[key].config.loginUrl) > -1) {
                    // 代填
                    sendMessageToContentScript({ idaas_config: appConfigMap[key] });
                }
            }
        }
    }
}, {urls: ['<all_urls>']}, ["blocking"]);



chrome.webRequest.onCompleted.addListener(details => {
    
}, {urls: ["<all_urls>"]}, ["responseHeaders"]);
	